## linksem 0.8+dfsg3

=== Makefile ===
.PHONY: default
default: build

.PHONY: build
build:
	$(MAKE) -C src

.PHONY: install
install:
	$(MAKE) -C src install

.PHONY: uninstall
uninstall:
	$(MAKE) -C src uninstall

.PHONY: clean
clean:
	$(MAKE) -C src clean

=== src/Makefile ===
USE_OCAMLBUILD ?= false

ifeq "$(USE_OCAMLBUILD)" "false"
	include no_ocamlbuild.mk
else
	include ocamlbuild.mk
endif

.PHONY: clean
clean:
	$(MAKE) -f ocamlbuild.mk clean
	$(MAKE) -f no_ocamlbuild.mk clean

=== test/link-01/Makefile ===
OUTPUTS := file1.o file2.o a.out

default: $(OUTPUTS)

# To avoid the complication of eh_frame, 
# i.e. an ABI-specific section masquerading as a "normal" progbits section,
# we disable that for the moment.
CFLAGS := -ffreestanding -g -fno-omit-frame-pointer -fno-unwind-tables -fno-asynchronous-unwind-tables -fno-dwarf2-cfi-asm
LDFLAGS := -static -nostdlib -nostartfiles -Wl,--defsym,_start=main -Wl,-Map,a.out.map -Wl,--no-ld-generated-unwind-info

a.out: file1.o file2.o
	$(CC) -o "$@" $+ $(LDFLAGS) $(LDLIBS)

clean:
	rm -f $(OUTPUTS)

=== test/tiny-fini-array/Makefile ===
OUTPUTS := file1.o file2.o tiny tiny.map

default: $(OUTPUTS)

# To avoid the complication of eh_frame, 
# i.e. an ABI-specific section masquerading as a "normal" progbits section,
# we disable that for the moment.
CFLAGS := -ffreestanding -g -fno-omit-frame-pointer -fno-unwind-tables -fno-asynchronous-unwind-tables -fno-dwarf2-cfi-asm
LDFLAGS := -static -nostdlib -nostartfiles -Wl,-Map,tiny.map -Wl,--no-ld-generated-unwind-info

tiny: file1.o file2.o
	$(CC) -o "$@" $+ $(LDFLAGS) $(LDLIBS)

clean:
	rm -f $(OUTPUTS)

=== debian/changelog ===
linksem (0.8+dfsg3-2build1) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 30 Aug 2025 09:44:57 +0200

linksem (0.8+dfsg3-2) unstable; urgency=medium

  * Bump Standards-Version to 4.7.2 (no changes)
  * Update year of d/copyright
  * Update my Debian email

 -- Bo YU <vimer@debian.org>  Wed, 09 Jul 2025 11:08:20 +0800

linksem (0.8+dfsg3-1) unstable; urgency=low

  * Initial release. (Closes: #1067819)

 -- Bo YU <tsu.yubo@gmail.com>  Wed, 09 Oct 2024 22:50:41 +0800

=== debian/control ===
Source: linksem
Priority: optional
Section: ocaml
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Bo YU <vimer@debian.org>
Build-Depends: debhelper-compat (= 13),
 ocaml,
 dh-ocaml (>= 1.2),
 lem,
 liblem-ocaml-dev,
 ocaml-findlib,
 ocamlbuild,
 libzarith-ocaml-dev,
 libnum-ocaml-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/rems-project/lem
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/ocaml-team/linksem.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/linksem

Package: liblinksem-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${ocaml:Depends}
Suggests:
 ocaml-findlib
Provides: ${ocaml:Provides}
Description: Formalisation of the core ELF and DWARF file formats written in Lem
 Linksem is a formalisation of substantial parts of ELF linking and DWARF debug
 information.
 .
 The ELF formalisation (and parts of the ABI formalisation) are currently also
 being used as a subcomponent of the rmem architectural exploration tool, for
 parsing ELF files and setting up initial machine states.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

include /usr/share/ocaml/ocamlvars.mk

DESTDIR := $(CURDIR)/debian/tmp
export INSTALLDIR := $(DESTDIR)$(OCAML_STDLIB_DIR)

# use lib of lem:
# see https://github.com/rems-project/lem/blob/master/README.md#without-opam
export LEMLIB=/usr/share/lem/library

%:
	dh $@ --with ocaml

override_dh_auto_build:
	$(MAKE)

override_dh_auto_install:
	echo $(INSTALLDIR)
	mkdir -p $(INSTALLDIR)
	$(MAKE)	install

override_dh_dwz:
	dh_dwz --no-dwz-multifile
